﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using HeuristicLab.Core;

namespace GradientBoostedTrees {
  public delegate double LineSearchFunc(int[] idx, int startIdx, int endIdx);

  public interface ILossFunction {
    double GetLoss(IEnumerable<double> target, IEnumerable<double> pred, IEnumerable<double> weight);
    IEnumerable<double> GetLossGradient(IEnumerable<double> target, IEnumerable<double> pred, IEnumerable<double> weight);
    LineSearchFunc GetLineSearchFunc(IEnumerable<double> target, IEnumerable<double> pred, IEnumerable<double> weight);
  }
}
